# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b30"
os.chdir("/home/marik/.sage/sage_notebook/worksheets/robert.marik/16/cells/0")
sage.server.notebook.interact.SAGE_CELL_ID=0
_sage_const_3 = Integer(3); _sage_const_2 = Integer(2); _sage_const_1 = Integer(1); _sage_const_0 = Integer(0); _sage_const_4 = Integer(4); _sage_const_9 = Integer(9); _sage_const_0p3 = RealNumber('0.3'); _sage_const_0p5 = RealNumber('0.5')
x,y, t, u, v =var('x y t u v')
INI_func='x^3+2*x^2+y^2-2'
INI_box='-2,2,-1,4'
INI_points='(0,0),(0,4)'
INI_curves='(t,t^2,-2,2),(t,4,-2,2)'
@interact
def _(func=input_box(INI_func,label="f(x,y)=",type=str),  bounds=input_box(INI_box,label="xmin,xmax,ymin,ymax",type=str),  st_points=input_box(INI_points,  label="points <br><small><small>(comma separated pairs, optionally with color)</small></small>", type=str),  bnd_curves=input_box(INI_curves,label="curves on boundary<br> <small><small><i>(x(t),y(t),tmin,tmax,'opt_color')</i></small></small>", type=str), show_planes=("Show zero planes", False),  show_axes=("Show axes", True),
 show_table=("Show table", True)):
 f=sage_eval('lambda x,y: ' + func)
 html(r'Function $ f(x,y)=%s$ '%latex(f(x,y)))
 xmin,xmax,ymin,ymax=sage_eval('('+bounds+')')
 A=plot3d(f(x,y),(x,xmin,xmax),(y,ymin,ymax),opacity=_sage_const_0p5 )
 if not(bool(st_points=='')):
     st_p=sage_eval('('+st_points+',)')
     html(r'<table border=1>')
     for current in range(len(st_p)):
         point_color='red'
         if bool(len(st_p[current])==_sage_const_3 ):
              point_color=st_p[current][_sage_const_2 ]
         x0=st_p[current][_sage_const_0 ]
         y0=st_p[current][_sage_const_1 ]
         z0=f(x0,y0)
         if show_table:
              html(r'<tr><td>$\quad f(%s,%s)\quad $</td><td>$\quad %s$</td>              </tr>'%(latex(x0),latex(y0),z0.n()))
         A=A+point3d((x0,y0,z0),size=_sage_const_9 ,rgbcolor=point_color)
     html(r'</table>')
 bnd_cc=sage_eval('('+bnd_curves+',)',locals={'t':t})
 if not(bool(st_points=='')):
     for current in range(len(bnd_cc)):
         bnd_c=bnd_cc[current]+('black',)
         A=A+parametric_plot3d((bnd_c[_sage_const_0 ],bnd_c[_sage_const_1 ],f(bnd_c[_sage_const_0 ],bnd_c[_sage_const_1 ])),             (t,bnd_c[_sage_const_2 ],bnd_c[_sage_const_3 ]),thickness=_sage_const_3 ,rgbcolor=bnd_c[_sage_const_4 ])
 if show_planes:
     A=A+plot3d(_sage_const_0 ,(x,xmin,xmax),(y,ymin,ymax),opacity=_sage_const_0p3 ,rgbcolor='gray')
     zmax=A.bounding_box()[_sage_const_1 ][_sage_const_2 ]
     zmin=A.bounding_box()[_sage_const_0 ][_sage_const_2 ]
     A=A+parametric_plot3d((u,_sage_const_0 ,v),(u,xmin,xmax),(v,zmin,zmax),opacity=_sage_const_0p3 ,rgbcolor='gray')
     A=A+parametric_plot3d((_sage_const_0 ,u,v),(u,ymin,ymax),(v,zmin,zmax),opacity=_sage_const_0p3 ,rgbcolor='gray')
 if show_axes:
     zmax=A.bounding_box()[_sage_const_1 ][_sage_const_2 ]
     zmin=A.bounding_box()[_sage_const_0 ][_sage_const_2 ]
     A=A+line3d([(xmin,_sage_const_0 ,_sage_const_0 ), (xmax,_sage_const_0 ,_sage_const_0 )], arrow_head=True,rgbcolor='black')
     A=A+line3d([(_sage_const_0 ,ymin,_sage_const_0 ), (_sage_const_0 ,ymax,_sage_const_0 )], arrow_head=True,rgbcolor='black')
     A=A+line3d([(_sage_const_0 ,_sage_const_0 ,zmin), (_sage_const_0 ,_sage_const_0 ,zmax)], arrow_head=True,rgbcolor='black')
 show(A)

print "e30"
